/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the JsonPatchDocument type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &JsonPatchDocument{}

// JsonPatchDocument struct for JsonPatchDocument
type JsonPatchDocument struct {
	Operations []Operation `json:"operations,omitempty"`
}

// NewJsonPatchDocument instantiates a new JsonPatchDocument object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewJsonPatchDocument() *JsonPatchDocument {
	this := JsonPatchDocument{}
	return &this
}

// NewJsonPatchDocumentWithDefaults instantiates a new JsonPatchDocument object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewJsonPatchDocumentWithDefaults() *JsonPatchDocument {
	this := JsonPatchDocument{}
	return &this
}

// GetOperations returns the Operations field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JsonPatchDocument) GetOperations() []Operation {
	if o == nil {
		var ret []Operation
		return ret
	}
	return o.Operations
}

// GetOperationsOk returns a tuple with the Operations field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JsonPatchDocument) GetOperationsOk() ([]Operation, bool) {
	if o == nil || IsNil(o.Operations) {
		return nil, false
	}
	return o.Operations, true
}

// HasOperations returns a boolean if a field has been set.
func (o *JsonPatchDocument) HasOperations() bool {
	if o != nil && !IsNil(o.Operations) {
		return true
	}

	return false
}

// SetOperations gets a reference to the given []Operation and assigns it to the Operations field.
func (o *JsonPatchDocument) SetOperations(v []Operation) {
	o.Operations = v
}

func (o JsonPatchDocument) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o JsonPatchDocument) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Operations != nil {
		toSerialize["operations"] = o.Operations
	}
	return toSerialize, nil
}

type NullableJsonPatchDocument struct {
	value *JsonPatchDocument
	isSet bool
}

func (v NullableJsonPatchDocument) Get() *JsonPatchDocument {
	return v.value
}

func (v *NullableJsonPatchDocument) Set(val *JsonPatchDocument) {
	v.value = val
	v.isSet = true
}

func (v NullableJsonPatchDocument) IsSet() bool {
	return v.isSet
}

func (v *NullableJsonPatchDocument) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableJsonPatchDocument(val *JsonPatchDocument) *NullableJsonPatchDocument {
	return &NullableJsonPatchDocument{value: val, isSet: true}
}

func (v NullableJsonPatchDocument) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableJsonPatchDocument) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
